package com.eactive.eai.batch.job.jobItem.kfb;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_KFB0810 extends DefaultTelegram implements TelegramService {

    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties telegramInfo;

    /**
     * 생성자
     */
    public SEND_KFB0810() {
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = calculateSendLength();
            if (!result) return false;

            // 해당 Transaction을 기동하는 코드로 본 파일전송 업무는 “KFBFTP”문자를 사용한다.
            compileField(0, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE), this.al_FieldProps[0]);

            //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
            compileField(1, ""+SEND_LENGTH, this.al_FieldProps[1]);
            
            //업무구분코드 -업무구분을 위하여 Set하는 문자로 본 파일전송 업무에서는 “FTP”문자를 사용키로 한다.
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);
            
            //대표기관코드 - 전문관련 금융기관을 나타내는 코드로서 금융기관 공동코드 (7자리)중 상위 3자리 금융기관 대표코드를 사용한다.
            // Ex) 국민: 004, 부산: 032, 농협: 011 등
            compileField(3, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[3]);
            
            //전문종별코드. 전문의 기능을 나타내는 구분코드로 전문종류별로 해당 전문코드를 Set하며 세부사항은 표준화 사항의 전문종별 코드를 참조한다.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);
            
            //거래구분코드 
            compileField(5, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[5]);

            //송수신 FLAG 전문을 발생시킨 기관을 나타내는 코드로 아래의 값중 해당코드를 Set한다.
            //“C”: 은행연합회에서 전문을 발생할 시
            //“B”: 은행에서 전문을 발생할 시
            compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[6]);
            
            //응답코드
            compileField(7, TelegramKeys.KFB_RET_CODE_SUCCESS, this.al_FieldProps[7]);
            
            //전송기준일자 --일단은 오늘날짜를 보내도록하자
            compileField(8, TelegramKeys.getYYYYMMDD(), this.al_FieldProps[8]);
            
            //업무별 Record Length -송수신을 하고자 하는 자료의 Record Length를 Set 한다.
            compileField(9, ""+batchDoc.getBatchMsg().getHeader().getRecLen(), this.al_FieldProps[9]);
            
            //전문 전송 일시 - 전문을 발신하는 기관에서 전문을 전송하는 일자와 시간을 Set한다.
            compileField(10, TelegramKeys.getMMddHHmmss(), this.al_FieldProps[10]);

            //전문 추적 번호 - 
            compileField(11, "" + this.getTrcNo(), this.al_FieldProps[11]);

            //<< 전문 완성

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<10; i++) { //은행연합회 전문의 헤더는 레코드 길이까지 임.
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=10; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }


    private boolean calculateSendLength () {
        try {
            for (int i=2; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            REAL_SEND_LENGTH = SEND_LENGTH;
            for (int i=0; i < 2 ; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                REAL_SEND_LENGTH += aField.length;
            }
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    private long getTrcNo(){
        String recvTrcNo = batchDoc.getBatchMsg().getTelegramBody().substring( 10 );
        try{
            long randomLong = Long.parseLong( recvTrcNo );
            return randomLong;
        } catch ( Exception e){
            return 0;
        }
    }
    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(10);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(7);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}
